#ifndef __Cm__CmConnect_ph__
#define __Cm__CmConnect_ph__

void CmConnectInitialize ();
void CmConnectSetDomain (char* name);
CmConnect CmConnectGetNameServer ();
void CmConnectKill (CmConnect connect);
CmConnect CmConnectWhoAmI ();
CmConnect CmConnectGetReference (char* name);
char* CmConnectGetComment (CmConnect connect);
void CmConnectSetHost (CmConnect connect, char* host_name);
void CmConnectSetMultiple (CmConnect connect);
char* CmConnectGetName (CmConnect connect);
CmConnect CmConnectGetServer (CmConnect connect);
CmConnectCondition CmConnectWaitWithTimeout (double seconds);
CmConnect CmConnectOpenServer (char* name);
CmConnect CmConnectOpenMultipleServer (char* name);
void CmConnectCheckBalance ();
void CmConnectCleanup ();
CmConnectPrinter CmConnectInstallPrinter (CmConnectPrinter printer);
void CmConnectForceStartup ();
CmConnectCondition CmConnectWaitOnIterator (CmMessageIterator it);
CmConnect CmConnectNew (char* name);
void CmConnectExit (CmErrorCode error);
CmConnectCondition CmConnectCheck ();
CmConnectCondition CmConnectWait ();
void CmConnectDebugOn ();
void CmConnectDebugOff ();
int CmConnectSend (CmConnect connect, char* message, int length);
CmMessage CmConnectTopMessage (CmConnect connect);
CmConnectStatus CmConnectCheckInputData (CmConnect connect);
CmMessage CmConnectGetMessage (CmConnect connect);
void CmConnectPushMessage (CmConnect connect);
CmMessage CmConnectPopMessage (CmConnect connect);
int CmConnectReceive (CmConnect connect, char* message, int length);
CmNameServerInfos CmNameServerGetInfos ();
char* CmConnectGetDomain ();
CmConnect CmConnectNewWithSocket (char* name, int socket_id);
void CmConnectSetOwner (CmConnect connect, char* owner);
int CmConnectTestPort (int port);
char* CmConnectTime ();
CmConnectIterator CmConnectGetIterator ();
CmConnect CmConnectGetNextAlive (CmConnectIterator it);
int CmConnectGetSocketId (CmConnect connect);
CmConnect CmConnectGetNthReference (char* name, int number);
void CmConnectSetSocketSize ( int snd, int rcv, char *tName );
int CmConnectGetPort (CmConnect connect);
char* CmConnectGetHost (CmConnect connect);
char* CmConnectGetOwner (CmConnect connect);
static int CmConnectGetPortAndName (CmConnect connect);
int CmConnectIsNameServer (CmConnect connect);
int CmConnectIsLocal (CmConnect connect);
int CmConnectIsMultiple (CmConnect connect);
void CmConnectSetName (CmConnect connect, char* newName);
void CmConnectSetPort (CmConnect connect, int port);
void CmConnectIteratorDelete (CmConnectIterator it);
int CmConnectSnprint( CmConnect c, char *txt, int size );
void CmServerSetComment (char* comment);

void CmConnectInitHandlers (CmConnect connect,
                            CmConnectReceiveHandler receive,
                            CmConnectRearmHandler rearm);

void CmConnectInstallMessageIterator (CmConnect connect,
                                      CmMessageIterator it);

void CmConnectGetStatistics (CmConnect connect, 
     			     CmConnectStatisticsRec* buffer);

CmConnect CmConnectNewWithAddress (CmConnect server,
                                   char* name, int port, char* host);

CmConnectConnectionHandler CmConnectInstallConnectionHandler (
    CmConnectConnectionHandler function);

CmConnectConnectionHandler CmConnectInstallDisconnectionHandler (
    CmConnectConnectionHandler function);

#endif /* __Cm__CmConnect_ph__ */
