package Cm;

import java.util.*;
import java.io.*;
import java.net.*;
import java.awt.*;
import java.applet.Applet;

class swap
{
  public static final int sizeof_short = 2;
  public static final int sizeof_int   = 4;
  public static final int sizeof_long  = 8;
  public static final int size = 2*sizeof_short + 1 + 2*sizeof_int + 1;
}

class head
{
  public static final int MessageTypeSize = 16;
  public static final int swap_offset = 0;
  public static final int magic_offset = swap_offset + swap.size;
  public static final int length_offset = magic_offset + swap.sizeof_int;
  public static final int tail_offset = length_offset + swap.sizeof_int;
  public static final int type_offset = tail_offset + swap.sizeof_int;
  public static final int size = type_offset + MessageTypeSize;
}

class tail
{
  public static final int magic_offset = 0;
  public static final int size = magic_offset + swap.sizeof_int;
}

class buffer
{
  public buffer ()
      {
        _data = null;
        _write_pos = 0;
        _read_pos = 0;
	_messageDebug = (Integer.getInteger ("CMMESSAGEDEBUG", 0)).intValue ();
      }

  public void reset ()
      {
        _write_pos = 0;
        _read_pos = 0;
      }
  
  public int extend (int bytes)
      {
        int pos = _write_pos;

        if ((_data == null) || ((_write_pos + bytes) > _data.length))
          {
            int frames = ((_write_pos + bytes) / FRAME_SIZE) + 1;
          
            byte[] new_data = new byte[frames * FRAME_SIZE];
          
            if (_data != null)
              {
		if (_messageDebug > 2)
		  {
		    System.out.println ("realloc");
		  }
                System.arraycopy (_data, 0, new_data, 0, _write_pos);
              }
          
            _data = new_data;
          }

	if (_messageDebug > 2)
	  {
	    System.out.print ("Extend> write_pos moved from ");
	    System.out.print (pos);
	  }

        _write_pos += bytes;

	if (_messageDebug > 2)
	  {
	    System.out.print (" to ");
	    System.out.println (_write_pos);
	  }
        return (pos);
      }
  
  public int move (int bytes)
      {
        if (_data == null) return (-1);
        if (_read_pos + bytes > _write_pos) return (-1);

        int pos = _read_pos;
        _read_pos += bytes;

        return (pos);
      }
  
  public void print ()
      {
        int bytes = _write_pos;
      
        // System.out.println (bytes);
      
        if (bytes > 0)
          {
            int i;
            int b;
          
            for (i = 0; i < bytes; i++)
              {
                if ((i % 16) == 0) 
                  {
                    System.out.println ();
                    int index = i;
                    int unit = 1000;
                    int d;
                    for (d = 0; d < 4; d++)
                      {
                        System.out.print (index/unit);
                        index %= unit;
                        unit /= 10;
                      }
                    System.out.print (": ");
                  }
              
                b = _data[i];
                if (b < 0) b += 256;
                System.out.print (Integer.toString (b/16, 16) + 
                            Integer.toString (b%16, 16));
              
                char c = (char) b;
              
                if ((c < ' ') || (c > 127)) c = '.';
                System.out.print (c);
                System.out.print (" ");
              }
          }
        System.out.println ();
      }
  
  public byte align (int pos)
      {
        pos %= ALIGNMENT;
        if (pos != 0) pos = ALIGNMENT - pos;
        return ((byte) pos);
      }
  
  public void write_synchro ()
      {
        byte offset = align (_write_pos + 1);
        write (offset);
        set_write_position (_write_pos + offset);
      }
  
  public void set_write_position (int pos)
      {
        int bytes = pos - _write_pos;

        if (bytes > 0)
          {
            int index = extend (bytes);
      
            for (; index < pos; index++)
              {
                _data[index] = 0;
              }
          }
      }

  public void shrink (int position)
      {
        if (_write_pos > position)
          {
            System.arraycopy (_data, position, _data, 0, _write_pos - position);
            _write_pos -= position;
            _read_pos = 0;
          }
        else if (_write_pos == position)
          {
            _write_pos = 0;
            _read_pos = 0;
          }
        else
          {
            _read_pos = 0;
          }
      }
  
  public void write (String value)
      {
        int length = value.length ();
        int pos = extend (length + 1);
        byte[] byte_value = value.getBytes ();

        System.arraycopy (byte_value, 0, _data, pos, byte_value.length);
          /* deprecated :      value.getBytes (0, length, _data, pos);       
             _data[pos + length] = 0; 
          */

      }
  
  public void write (byte[] value)
      {
        int pos = extend (value.length);
        System.arraycopy (value, 0, 
                          _data, pos, 
                          value.length);
      }
  
  public void write (byte value)
      {
        int pos = extend (1);
        _data[pos] = value;
      }
  
  public void write (short value)
      {
        int pos = extend (2);
      
        int index = 0;
      
        while (value != 0)
          {
            _data[pos + index] = (byte) (value & 255);
            value >>= 8;
            index++;
            if (index >= 2) break;
          }
      
        while (index < 2)
          {
            _data[pos + index] = (byte) 0;
            index++;
          }
      }
  
  public void write (int value)
      {
        int pos = extend (4);
      
        int index = 0;
      
        while (value != 0)
          {
            _data[pos + index] = (byte) (value & 255);
            value >>= 8;
            index++;
            if (index >= 4) break;
          }
      
        while (index < 4)
          {
            _data[pos + index] = (byte) 0;
            index++;
          }
      }
  
  public void write (long value)
      {
        int pos = extend (8);
      
        int index = 0;
      
        while (value != 0)
          {
            _data[pos + index] = (byte) (value & 255);
            value >>= 8;
            index++;
            if (index >= 8) break;
          }
      
        while (index < 8)
          {
            _data[pos + index] = (byte) 0;
            index++;
          }
      }
  
  public void write (float value)
      {
        int pos = _write_pos;
        int ival = Float.floatToIntBits (value);
      
        write (ival);

        int i;
        for (i = 0; i < 2; i++)
          {
            byte b = _data[pos + i];
            _data[pos + i] = _data[pos + 3 - i];
            _data[pos + 3 - i] = b;
          }
      }
  
  public void write (double value)
      {
        int pos = _write_pos;
        long lval = Double.doubleToLongBits (value);
      
        write (lval);

        int i;
        for (i = 0; i < 4; i++)
          {
            byte b = _data[pos + i];
            _data[pos + i] = _data[pos + 7 - i];
            _data[pos + 7 - i] = b;
          }
      }

  public void write (InputStream stream)
      {
        try
          {
            int available = stream.available ();
            if (available == 0) return;

	    if (_messageDebug > 1)
	      {
		System.out.print ("write (stream)> wpos = ");
		System.out.println (_write_pos);
	      }
            int pos = extend (available);


	    if (_messageDebug  > 1)
	      {
		System.out.print ("write (stream)2> wpos = ");
		System.out.print (_write_pos);
		System.out.print (" reading at pos = ");
		System.out.println (pos);
	      }
            int bytes_read = stream.read (_data, pos, available);
 	    if (_messageDebug  == 1)
	      {
		System.out.println ("message.write : bytes_read = "+bytes_read);
	      }
	    if (bytes_read < available)
	      {
		_write_pos -= available - bytes_read;
	      }
 	    if (_messageDebug  > 2)
	      {
		print ();
	      }
          }
        catch (Exception e)
          {
          }
      }
  
  public void read_synchro ()
      {
        int offset = read_byte ();
        move (offset);
      }
  
  public String read_string ()
      {
        int length = -1;
        int index;

	if (_messageDebug > 1)
	  {
	    System.out.println ("read_string at " + String.valueOf (_read_pos));
	  }
        for (index = _read_pos; index < _write_pos; index++)
          {
            if (_data[index] == 0)
              {
                length = index - _read_pos;
                break;
              }
          }

        if (length == -1) return (null);

        int pos = move (length + 1);
        if (pos >= 0)
          {
            return (new String (_data, pos, length));
          }
        else
          {
            return (null);
          }
      }
  
  public byte[] read_bytes (int length)
      {
        int pos = move (length);
        if (pos >= 0)
        {
          byte[] result = new byte[length];
          System.arraycopy (_data, pos, result, 0, length);
          return (result);
        }
        else
        {
          return (null);
        }
      }
  
  public byte read_byte ()
      {
        int pos = move (1);
        if (pos >= 0)
          {
            return (_data[pos]);
          }
        else
          {
            return (0);
          }
      }
  
  public short read_short ()
      {
        int pos = move (2);
        if (pos >= 0)
          {
            short value = 0;

            int index;

            for (index = 1; index >= 0; index--)
              {
                int b = _data[pos + index];
                if (b < 0) b += 256;
                value = (short) ((value * 256) + b);
              }

            return (value);
          }
        else
          {
            return (0);
          }
      }
  
  public int read_int ()
      {
        int pos = move (4);
        if (pos >= 0)
          {
            int value = 0;

            int index;

            for (index = 3; index >= 0; index--)
              {
                int b = _data[pos + index];
                if (b < 0) b += 256;
                value = (value * 256) + b;

		if (_messageDebug > 1)
		  {
		    System.out.print ("read_int> data = ");
		    System.out.print (_data[pos + index]);
		    System.out.print (" b = ");
		    System.out.print (b);
		    System.out.print (" value = ");
		    System.out.print (value);
		    System.out.print (" $");
		    System.out.println (Integer.toString (value, 16));
		  }
              }

            return (value);
          }
        else
          {
            return (0);
          }
      }
  
  public long read_long ()
      {
        int pos = move (8);
        if (pos >= 0)
          {
            long value = 0;

            int index;

            for (index = 7; index >= 0; index--)
              {
                int b = _data[pos + index];
                if (b < 0) b += 256;
                value = (value * 256) + b;
              }

            return (value);
          }
        else
          {
            return (0);
          }
      }
  
  public float read_float ()
      {
        int pos = move (4);
        if (pos >= 0)
          {
            int value = 0;

            int index;

            for (index = 3; index >= 0; index--)
              {
                int b = _data[pos + index];
                if (b < 0) b += 256;
                value = (value * 256) + b;
              }

            return (Float.intBitsToFloat (value));
          }
        else
          {
            return (0);
          }
      }
  
  public double read_double ()
      {
        int pos = move (8);
        if (pos >= 0)
          {
            long value = 0;

            int index;

            for (index = 7; index >= 0; index--)
              {
                int b = _data[pos + index];
                if (b < 0) b += 256;
                value = (value * 256) + b;
              }

            return (Double.longBitsToDouble (value));
          }
        else
          {
            return (0);
          }
      }

  private static final int FRAME_SIZE = 256;
  private static final int ALIGNMENT = 8;
  byte[] _data;
  int    _write_pos;
  int    _read_pos;
  int _messageDebug = 0;
}

public class Message extends buffer
{
  public static final int MAGIC_WORD = 0xDEADDEAD;
  public static final int SIZEOF_PROTOCOL = head.size + tail.size;
  public static final byte ItemChar    = 0;
  public static final byte ItemShort   = 1;
  public static final byte ItemInt     = 2;
  public static final byte ItemLong    = 3;
  public static final byte ItemFloat   = 4;
  public static final byte ItemDouble  = 5;
  public static final byte ItemArray   = 6;
  public static final byte ItemText    = 7;
  public static final byte ItemBytes   = 8;
  public static final byte ItemTail    = 9;
  public static final byte ItemUnknown = 10;
  
  public static final byte IsDead     = 0;
  public static final byte IsNotReady = 1;
  public static final byte IsNew      = 2;
  public static final byte IsNotEmpty = 3;
  public static final byte IsClosed   = 4;
  public static final byte IsSending  = 5;

  public static final byte MessageOk                 = 0;
  public static final byte MessageError              = 1;
  public static final byte MessageNoBuffer           = 2;
  public static final byte MessageUnsufficientBuffer = 3;
  public static final byte MessageIncompleteData     = 4;
  public static final byte MessageOverlay            = 5;
  public static final byte MessageBadHead            = 6;
  public static final byte MessageBadTail            = 7;
  public static final byte MessageBadLength          = 8;
  public static final byte MessageBadData            = 9;
  public static final byte MessageBadConnect         = 10;

  public Message ()
      {
        _state = IsNew;
      }

  public Message (String type)
      {
        _state = IsNew;
        set_type (type);
      }

  public boolean send (String destination)
      {
        Connect connect = Server.get_connection (destination);
        if (connect == null) 
          {
            System.out.println ("no connect");
            return (false);
          }
        Socket socket = connect.get_socket ();
        if (socket == null) 
          {
            System.out.println ("no socket");
            return (false);
          }

        return (send (socket));
      }

  public boolean send (Socket socket)
      {
        if ((_state == IsDead) ||
            (_state == IsNew)) return (false);

        if (_state == IsNotEmpty)
          {
            put_tail ();
          }

        if (_state != IsClosed) return (false);

          //print ();
      
        try
          {
            OutputStream stream = socket.getOutputStream ();
            DataOutputStream file = new DataOutputStream (stream);
            file.write (_data, 0, _write_pos);
          }
        catch (Exception e)
          {
            return (false);
          }

        return (true);
      }
  
  public void reset ()
      {
        if (_state == IsSending) return;
      
        super.reset ();
      
        _state = IsNew;
      }
  
  public void skip_frame ()
      {
        int length = head_get_length ();
	if (_messageDebug  >= 1)
	  {
	    
	    System.out.print ("skip_frame : write_pos :" + _write_pos);
	    System.out.print (" read_pos : " + _read_pos);
	    System.out.println (" length : " + length);
	  }
        shrink (length);
      }
  
  public void set_type (String type)
      {
        if (!check ()) return;
      
        int save_position = _write_pos;
        _write_pos = head.type_offset;
        put_type (type);
        _write_pos = Math.max (save_position, head.size);
      }
  
  public void put_char (char value)
      {
        if (!check ()) return;
        put_item_type (ItemChar);
        write ((byte) value);
      }
  
  public void put_short (short value)
      {
        if (!check ()) return;
        put_item_type (ItemShort);
        write (value);
      }
  
  public void put_int (int value)
      {
        if (!check ()) return;
        put_item_type (ItemInt);
        write (value);
      }
  
  public void put_float (float value)
      {
        if (!check ()) return;
        put_item_type (ItemFloat);
        write (value);
      }
  
  public void put_double (double value)
      {
        if (!check ()) return;
        put_item_type (ItemDouble);
        write (value);
      }
  
  public void put_bytes (byte[] bytes)
      {
        if (!check ()) return;
        put_item_type (ItemBytes);
        put_int (bytes.length);
        write (bytes);
      }
  
  public void put_text (String text)
      {
        if (!check ()) return;
        put_item_type (ItemText);
        put_item_type (ItemBytes);
        int length = text.length ();
        put_int (length + 1);
        int pos = extend (length + 1);
        byte[] byte_text = text.getBytes ();
        System.arraycopy (byte_text, 0, _data, pos, byte_text.length);
          /* deprecated :
             text.getBytes (0, length, _data, pos);
             _data[pos + length] = 0; */
      }
  
  private void put_head ()
      {
        write ("0201-04030201");
        write (MAGIC_WORD);
        write (0);
        write (0);
        put_type ("");
      }
  
  public void put_tail ()
      {
        if (_state != IsNotEmpty) return;

        put_item_type (ItemTail);
      
        int offset = _write_pos;
        set_tail_offset (offset);
      
        write (MAGIC_WORD);
        write_synchro ();
      
        int length = _write_pos;
        set_length (length);

        _state = IsClosed;
      }

  private void set_tail_offset (int offset)
      {
        int pos = _write_pos;

        _write_pos = head.tail_offset;

        write (offset);

        _write_pos = pos;
      }

  private void set_length (int length)
      {
        int pos = _write_pos;

        _write_pos = head.length_offset;

        write (length);

        _write_pos = pos;
      }
  
  private void put_item_type (byte type)
      {
        if (!check ()) return;
        write (type);
        write_synchro ();
      }

  private void put_type (String type)
      {
        if (type.length () < 16)
          {
            write (type);
          }
        else
          {
            write (type.substring (0, 15));
          }

        write ((byte) 0);
      }
  
  private boolean check ()
      {
        if (_state == IsDead) 
          {
            return (false);
          }
        if (_state == IsSending) 
          {
            return (false);
          }
        if (_state == IsClosed) reset ();
        if (_state == IsNew)
          {
            reset ();
            put_head ();
            _state = IsNotEmpty;
          }
        return (true);
      }
  
  public int check_after_reception ()
      {
        int bytes = _write_pos;

	if (_messageDebug  == 1)
	  {
	    System.out.print ("check_after_reception1> wpos = ");
	    System.out.println (_write_pos);
	  }
        if (_state == IsDead) return (MessageError);
        if (_data == null) return (MessageNoBuffer);

        if (bytes < head.size)
          {
	    if (_messageDebug  == 1)
	      {
		System.out.print ("check_after_reception2> wpos = ");
		System.out.println (_write_pos);
		print ();
	      }
            return (MessageIncompleteData);
          }

        if (!check_head ())
          {
	    if (_messageDebug  == 1)
	      {
		System.out.print ("check_after_reception3> wpos = ");
		System.out.println (_write_pos);
	      }
            return (MessageBadHead);
          }

        int length = head_get_length ();

        if (length < SIZEOF_PROTOCOL)
          {
	    if (_messageDebug  == 1)
	      {
		System.out.print ("check_after_reception4> wpos = ");
		System.out.println (_write_pos);
	      }
            return (MessageBadLength);
          }

        if (_write_pos < length)
          {
	    if (_messageDebug  == 1)
	      {
		System.out.print ("check_after_reception5> wpos = ");
		System.out.print (_write_pos);
		System.out.print (" length = ");
		System.out.println (length);
	      }
            return (MessageIncompleteData);
          }

          // It seems that we have received the entire message.


        if (!check_tail ())
          {
	    if (_messageDebug  == 1)
	      {
		System.out.print ("check_after_reception6> wpos = ");
		System.out.println (_write_pos);
		if (_messageDebug > 1)
		    print ();
	      }
            return (MessageBadTail);
          }

          // The message is complete.

	if (_messageDebug == 1)
	  {
	    System.out.print ("check_after_reception7> wpos = ");
	    System.out.println (_write_pos);
	  }

        _read_pos = head.size;

        return (MessageOk);
      }

  public int get_item_type ()
      {
        int pos = _read_pos;
        int actual_type = read_byte ();
        _read_pos = pos;

        return (actual_type);
      }
  
  public String get_type ()
      {
        int pos = _read_pos;

        _read_pos = head.type_offset;

        String type = read_string ();

        _read_pos = pos;

        return (type);
      }
  
  public char get_char ()
      {
        if (!check_item_type (ItemChar)) return (0);
        return ((char) read_byte ());
      }
  
  public short get_short ()
      {
        if (!check_item_type (ItemShort)) return (0);
        return (read_short ());
      }
  
  public int get_int ()
      {
        if (!check_item_type (ItemInt)) return (0);
        return (read_int ());
      }
  
  public float get_float ()
      {
        if (!check_item_type (ItemFloat)) return (0);
        return (read_float ());
      }
  
  public double get_double ()
      {
        if (!check_item_type (ItemDouble)) return (0);
        return (read_double ());
      }
  
  public byte[] get_bytes ()
      {
        if (!check_item_type (ItemBytes)) return (null);

        int length = get_int ();
        return (read_bytes (length));
      }
  
  public String get_text ()
      {
        if (!check_item_type (ItemText)) return (null);
        if (!check_item_type (ItemBytes)) return (null);

        int length = get_int ();

        byte[] b = read_bytes (length);

        return (new String (b, 0, length - 1));
      }
  
  private boolean check_head ()
      {
        int pos = _read_pos;
        int magic;

        _read_pos = 0;
        read_string ();
        magic = read_int ();
        if (magic != MAGIC_WORD) 
          {
	    if (_messageDebug > 1)
	      {
		System.out.print ("check_head2> magic is ");
		System.out.print (Integer.toString (magic, 16));
		System.out.print (" instead of ");
		System.out.println (Integer.toString (MAGIC_WORD, 16));
	      }
            _read_pos = pos;
            return (false);
          }
        read_int ();
        read_int ();
        get_type ();

        _read_pos = pos;

        return (true);
      }
  
  private int head_get_length ()
      {
        int pos = _read_pos;

        _read_pos = head.length_offset;
        int length = read_int ();

        _read_pos = pos;

        return (length);
      }
  
  private int head_get_tail_offset ()
      {
        int pos = _read_pos;

        _read_pos = head.tail_offset;
        int offset = read_int ();

        _read_pos = pos;

        return (offset);
      }
  
  public boolean check_tail ()
      {
        int pos = _read_pos;

        int offset = head_get_tail_offset ();

        _read_pos = offset;

          //if (!check_item_type (ItemTail)) 
          //  {
          //    _read_pos = pos;
          //    return (false);
          //  }
      
          //move (tail.size);
        if (read_int () != MAGIC_WORD) 
          {
            _read_pos = pos;
            return (false);
          }

        read_synchro ();
      
        return (true);
      }
  
  private boolean check_item_type (byte type)
      {
        int pos = _read_pos;
        int actual_type = read_byte ();
        if (actual_type != type) 
          {

	    if (_messageDebug  == 1)
	      {
		System.out.print ("check_item_type1> found item type");
		System.out.print (actual_type);
		System.out.print (" instead of ");
		System.out.print (type);
		System.out.print (" at ");
		System.out.println (pos);
	      }
            _read_pos = pos;
            return (false);
          }
        read_synchro ();

          //System.out.print ("check_item_type2> found good item type");
          //System.out.println (type);

        return (true);
      }

  private int _state;
}

