/*---------------------------------------------------------------------------!
!                                                                            !
!              Copyright 1989 by Microware Systems Corporation               !
!                          Reproduced Under License                          !
!                                                                            !
!  This source code is the proprietary confidential property of Microware    !
!  Systems Corporation, and is provided to licensee for documentation and    !
!  educational purposes only. Reproduction, publication, or distribution     !
!  in any form to any party other than the licensee is strictly prohibited.  !
!                                                                            !
!---------------------------------------------------------------------------*/

#define MAX_NOFILE	32	/* This should not exist ! */
#define	NBBY	8		/* number of bits in a byte */
/*
 * Select uses bit masks of file descriptors in longs.
 * These macros manipulate such bit fields (the filesystem macros use chars).
 * FD_SETSIZE may be defined by the user, but the default here
 * should be >= NOFILE (param.h).
 */
#define	FD_SETSIZE	MAX_NOFILE

/* How many things we'll allow select to use. 0 if unlimited */
#define MAXSELFD	MAX_NOFILE
typedef long	fd_mask;
#define NFDBITS	(sizeof(fd_mask) * NBBY)	/* bits per mask (power of 2!)*/
#define NFDSHIFT 5				/* Shift based on above */
#define	howmany(x, y)	(((x)+((y)-1))/(y))

typedef	struct fd_set {
	fd_mask	fds_bits[howmany(FD_SETSIZE, NFDBITS)];
} fd_set;

#define	FD_SET(n, p)	((p)->fds_bits[(n)/NFDBITS] |= (1 << ((n) % NFDBITS)))
#define	FD_CLR(n, p)	((p)->fds_bits[(n)/NFDBITS] &= ~(1 << ((n) % NFDBITS)))
#define	FD_ISSET(n, p)	((p)->fds_bits[(n)/NFDBITS] & (1 << ((n) % NFDBITS)))
#define FD_ZERO(p)	bzero((char *)(p), sizeof(*(p)))
